package wenrgise.hrms.ejb.business;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import wenrgise.common.bean.BaseHeaderBean;
import wenrgise.common.exception.EnrgiseApplicationException;
import wenrgise.common.exception.EnrgiseMessageKeyException;
import wenrgise.common.exception.EnrgiseSystemException;
import wenrgise.common.utility.EnrgiseUtil;
import wenrgise.common.utility.MessageKey;
import wenrgise.common.utility.RecordMetaInfo;
import wenrgise.common.utility.UserInfo;
import wenrgise.common.vo.BaseDetailVO;
import wenrgise.ejb.common.helper.DBObject;
import wenrgise.ejb.common.helper.QueryRow;
import wenrgise.ejb.common.helper.QueryValue;
import wenrgise.ejb.common.utility.DBUtilitiesBean;
import wenrgise.hrms.bean.HrmOrgQualMstDtlBean;

public class HrmOrgQualMstBO extends HrmBaseBO {
  public HrmOrgQualMstBO() {}
  
  public HrmOrgQualMstBO(UserInfo oUserInfo) {
    super(oUserInfo);
  }
  
  public RecordMetaInfo getHrmQualificationDtlMetaInfo() throws EnrgiseApplicationException, EnrgiseSystemException {
    ArrayList arylstParam = new ArrayList();
    DBUtilitiesBean oBean = new DBUtilitiesBean();
    arylstParam = new ArrayList();
    arylstParam.add(new DBObject(1, 2, -5));
    arylstParam.add(new DBObject(2, 2, 93));
    arylstParam.add(new DBObject(3, 2, 12));
    arylstParam.add(new DBObject(4, 2, 12));
    arylstParam.add(new DBObject(5, 2, 4));
    ArrayList arylstOutArray = oBean.callProc(arylstParam, "HRMORGQUALIFICATIONMST.proc_HrQualificationDtlCount(?,?,?,?,?)");
    RecordMetaInfo oRecordMetaInfo = new RecordMetaInfo();
    DBObject oTotalRecord = arylstOutArray.get(0);
    oRecordMetaInfo.setRecordCount(((Long)oTotalRecord.getObject()).longValue());
    DBObject oTimeObject = arylstOutArray.get(1);
    oRecordMetaInfo.setOWhenPicked((Timestamp)oTimeObject.getObject());
    return oRecordMetaInfo;
  }
  
  public ArrayList getHrmQualificationDetailInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    ArrayList arylstParam = new ArrayList();
    DBUtilitiesBean oBean = new DBUtilitiesBean();
    int count = 0;
    BaseDetailVO oBaseDetailVO = null;
    ArrayList arylstHrmQualDetail = null;
    arylstParam = new ArrayList();
    arylstParam.add(new DBObject(1, 1, -5, new Long(lDetailFirstPosition)));
    arylstParam.add(new DBObject(2, 1, -5, new Long(lDetailLastPosition)));
    arylstParam.add(new DBObject(3, 2, -10));
    arylstParam.add(new DBObject(4, 2, 12));
    arylstParam.add(new DBObject(5, 2, 12));
    arylstParam.add(new DBObject(6, 2, 4));
    ArrayList arylstOutArray = oBean.callProc(arylstParam, "HRMORGQUALIFICATIONMST.proc_GetQualificationDtl(?,?,?,?,?,?)");
    DBObject oOutObject = arylstOutArray.get(0);
    ArrayList arylstList = (ArrayList)oOutObject.getObject();
    if (arylstList.size() == 0)
      throw new EnrgiseApplicationException("wenrgise.hrms.norecordfound", "M"); 
    QueryRow oRow = null;
    QueryValue oValue = null;
    HashMap oColumns = null;
    Iterator itrBean = arylstList.iterator();
    while (itrBean.hasNext()) {
      if (count == 0)
        arylstHrmQualDetail = new ArrayList(); 
      count++;
      oRow = itrBean.next();
      HrmOrgQualMstDtlBean oQualificationBean = new HrmOrgQualMstDtlBean();
      oQualificationBean.setDetailId(oRow.get("ID").getString());
      oQualificationBean.setTxtApprovingAuthority(oRow.get("APPROVAL_BODY").getString());
      oQualificationBean.setTxtCode(oRow.get("CODE").getString());
      oQualificationBean.setTxtNoOfYears(oRow.get("DURATION_YEARS").getString());
      oQualificationBean.setTxtQualification(oRow.get("NAME").getString());
      arylstHrmQualDetail.add(oQualificationBean);
    } 
    return arylstHrmQualDetail;
  }
  
  public void updateHeaderImpl(BaseHeaderBean oBaseHeaderBean) throws EnrgiseSystemException {
    System.out.println("Update ille!");
  }
  
  public String saveNewHeaderImpl(BaseHeaderBean oBaseHeaderBean) throws EnrgiseSystemException {
    return "saveNewHeaderImpl ille!";
  }
  
  public String saveHeaderImpl(BaseHeaderBean oBaseHeaderBean, String param1) throws EnrgiseSystemException {
    return "true";
  }
  
  public void initializeBOImpl() {
    this.headerTable = "HRM_QUAL_MST";
  }
  
  public void saveDetailImpl(String sHeaderPrimaryKey, String sScreenName, ArrayList arylstDetailBeanArray) throws EnrgiseSystemException {
    if (sScreenName.equalsIgnoreCase("HrmOrgQualMst"))
      saveHrmQualificationDetail(arylstDetailBeanArray); 
  }
  
  private void saveHrmQualificationDetail(ArrayList arylstDetailBeanArray) throws EnrgiseSystemException {
    boolean bInsert = false;
    boolean bUpdate = false;
    boolean bDelete = false;
    ArrayList arylstParam = new ArrayList();
    DBUtilitiesBean oBean = null;
    DBUtilitiesBean oBean1 = null;
    Iterator itrBean = arylstDetailBeanArray.iterator();
    while (itrBean.hasNext()) {
      HrmOrgQualMstDtlBean oHrmOrgQualMstDtlBean = itrBean.next();
      if (oHrmOrgQualMstDtlBean.getStatus().equals("N")) {
        if (!bInsert) {
          oBean = new DBUtilitiesBean();
          oBean.createBatch("HRMORGQUALIFICATIONMST.proc_UpsertHrQualificationMst(?,?,?,?,?,?,?,?)");
          bInsert = true;
        } 
        arylstParam = new ArrayList();
        arylstParam.add(new DBObject(1, 1, 12, "I"));
        arylstParam.add(new DBObject(2, 1, 12, null));
        arylstParam.add(new DBObject(3, 1, 12, oHrmOrgQualMstDtlBean.getTxtCode()));
        arylstParam.add(new DBObject(4, 1, 12, oHrmOrgQualMstDtlBean.getTxtQualification()));
        arylstParam.add(new DBObject(5, 1, 12, oHrmOrgQualMstDtlBean.getTxtNoOfYears()));
        arylstParam.add(new DBObject(6, 1, 12, oHrmOrgQualMstDtlBean.getTxtApprovingAuthority()));
        arylstParam.add(new DBObject(7, 1, 12, this.oUserInfo.getUserTypeId()));
        arylstParam.add(new DBObject(8, 1, 12, this.oUserInfo.getSiteId()));
        oBean.addToBatch(arylstParam);
        continue;
      } 
      if (oHrmOrgQualMstDtlBean.getStatus().equals("U")) {
        if (!bUpdate) {
          oBean = new DBUtilitiesBean();
          oBean.createBatch("HRMORGQUALIFICATIONMST.proc_UpsertHrQualificationMst(?,?,?,?,?,?,?,?)");
          bUpdate = true;
        } 
        arylstParam = new ArrayList();
        arylstParam.add(new DBObject(1, 1, 12, "U"));
        arylstParam.add(new DBObject(2, 1, 12, oHrmOrgQualMstDtlBean.getDetailId()));
        arylstParam.add(new DBObject(3, 1, 12, oHrmOrgQualMstDtlBean.getTxtCode()));
        arylstParam.add(new DBObject(4, 1, 12, oHrmOrgQualMstDtlBean.getTxtQualification()));
        arylstParam.add(new DBObject(5, 1, 12, oHrmOrgQualMstDtlBean.getTxtNoOfYears()));
        arylstParam.add(new DBObject(6, 1, 12, oHrmOrgQualMstDtlBean.getTxtApprovingAuthority()));
        arylstParam.add(new DBObject(7, 1, 12, this.oUserInfo.getUserTypeId()));
        arylstParam.add(new DBObject(8, 1, 12, this.oUserInfo.getSiteId()));
        oBean.addToBatch(arylstParam);
        continue;
      } 
      if (oHrmOrgQualMstDtlBean.getStatus().equals("D")) {
        if (!bDelete) {
          oBean1 = new DBUtilitiesBean();
          oBean1.createBatch("HRMORGQUALIFICATIONMST.proc_DeleteQualMstDtl(?)");
          bDelete = true;
        } 
        arylstParam = new ArrayList();
        arylstParam.add(new DBObject(1, 1, 12, oHrmOrgQualMstDtlBean.getDetailId()));
        oBean1.addToBatch(arylstParam);
      } 
    } 
    if (bInsert)
      oBean.executeBatch(); 
    if (bUpdate)
      oBean.executeBatch(); 
    if (bDelete)
      oBean1.executeBatch(); 
  }
  
  public void additionalFieldValidationImpl(BaseHeaderBean oBaseHeaderBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList arylstDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked) throws EnrgiseApplicationException, EnrgiseSystemException {
    ArrayList arylstErrorList = new ArrayList();
    if (bDetailDataChanged)
      if (sScreenName.equalsIgnoreCase("HrmOrgQualMst")) {
        Iterator itrBean1 = arylstDetailBeanArray.iterator();
        int iCount = 1;
        while (itrBean1.hasNext()) {
          HrmOrgQualMstDtlBean oHrmOrgQualMstDtlBean = itrBean1.next();
          if (!oHrmOrgQualMstDtlBean.getStatus().equalsIgnoreCase("D"))
            checkMandatory(oHrmOrgQualMstDtlBean, iCount, arylstErrorList); 
          iCount++;
        } 
      }  
    reportError(arylstErrorList);
  }
  
  private void checkMandatory(HrmOrgQualMstDtlBean oHrmOrgQualMstDtlBean, int iCount, ArrayList arylstErrorList) throws EnrgiseSystemException, EnrgiseApplicationException {
    if (!EnrgiseUtil.checkString(oHrmOrgQualMstDtlBean.getTxtQualification())) {
      MessageKey oMessageKey = new MessageKey("hrm.HrmQualificationMaster.txtQualification");
      ArrayList oParams = new ArrayList();
      oParams.add(oMessageKey);
      oParams.add(new Integer(iCount));
      arylstErrorList.add(new EnrgiseMessageKeyException("wenrgise.common.detail.mandatoryFieldMissing", oParams, "E"));
    } 
    if (!EnrgiseUtil.checkString(oHrmOrgQualMstDtlBean.getTxtCode())) {
      MessageKey oMessageKey = new MessageKey("hrm.HrmQualificationMaster.txtCode");
      ArrayList oParams = new ArrayList();
      oParams.add(oMessageKey);
      oParams.add(String.valueOf(iCount));
      arylstErrorList.add(new EnrgiseMessageKeyException("wenrgise.common.detail.mandatoryFieldMissing", oParams, "E"));
    } 
    reportError(arylstErrorList);
  }
  
  public void additionalTimestampValidationImpl(BaseHeaderBean param1, Timestamp param2, String param3, String param4, boolean param5, ArrayList param6, boolean param7, Timestamp param8) {}
  
  public void additionalBusinessValidationImpl(BaseHeaderBean oBaseHeaderBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList arylstDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked) throws EnrgiseApplicationException, EnrgiseSystemException {
    ArrayList arylstErrorList = new ArrayList();
    if (bDetailDataChanged)
      if (sScreenName.equalsIgnoreCase("HrmOrgQualMst")) {
        Iterator itrBean1 = arylstDetailBeanArray.iterator();
        while (itrBean1.hasNext()) {
          HrmOrgQualMstDtlBean oHrmOrgQualMstDtlBean = itrBean1.next();
          if (!oHrmOrgQualMstDtlBean.getStatus().equalsIgnoreCase("D"))
            EnrgiseUtil.checkDuplicate(arylstDetailBeanArray, "txtCode", "hrm.HrmQualificationMaster.txtCode", arylstErrorList, true); 
        } 
      }  
    reportError(arylstErrorList);
  }
}
